'use strict'
function MultiLang () {
    this.appLang = ''
    this.appLangString = ''
    this.packageLang = 'null'
    this.initArguments = {}
    this.langList = []
    this.currentLangName = ''
    // this.getAppLang()
}

var _localLangNameMap = {
    'cn' : {langName: 'cn', localName: '中文(简体)'},
    'tw' : {langName: 'tw', localName: '中文(繁體)'},
    'en' : {langName: 'en', localName: 'English'},
    'th' : {langName: 'th', localName: 'ไทย'},
    'vn' : {langName: 'vn', localName: 'tiếng Việt'},
    'ru' : {langName: 'ru', localName: 'русский'},
    'id' : {langName: 'id', localName: 'Indonesia'},
    'ko' : {langName: 'ko', localName: '한국의'},
    'in' : {langName: 'in', localName: 'हिन्दी'},
    'ar' : {langName: 'ar', localName: 'العربية'},
    'tr' : {langName: 'tr', localName: 'Türk'},
    'es' : {langName: 'es', localName: 'español'},
    'my' : {langName: 'my', localName: 'Malay'},
    'pt' : {langName: 'pt', localName: 'português'},
    'ja' : {langName: 'ja', localName: '日本語'},
    'kh' : {langName: 'kh', localName: 'ភាសាខ្មែរ'},
}

var _isArray = function(object) {
    return Object.prototype.toString.call(object) === '[object Array]';
}

var _createLangList = function(langArray) {
    if (!langArray || !_isArray(langArray)) return [];

    var resultArray = [];
    langArray.forEach(function(langName){
        if (langName in _localLangNameMap) {
            resultArray.push(_localLangNameMap[langName])
        }
    })
    return resultArray;
}

var _recordLangList = function(allName, useLang) {
    var recordList  = [];
    if (allName) {
        for (var key in allName) {
            recordList.push(key);
        }
    }
    else if (useLang && _isArray(useLang)) {
        useLang.forEach(function(value) {
            recordList.push(value);
        })
    }
    return recordList;
}

MultiLang.prototype.langZip = [
    ['cn', 'cn,zh,zh-hans,zh-cn,zh-hans-cn,zh-sg,zh-hans-sg'],
    ['tw', 'tw,zh-hant,zh-hk,zh-mo,zh-tw,zh-hant-hk,zh-hant-mo,zh-hant-tw'],
    ['en', 'en,en-au,en-bz,en-ca,en-cb,en-ie,en-jm,en-nz,en-ph,en-za,en-tt,en-gb,en-us,en-zw,en-sg'],
    ['th', 'th,th-th'],
    ['vn', 'vn,vi-vn,vi,vn-vn'],
    ['ru', 'ru,ru-ru,ru-mo'],
    ['id', 'id,id-id,in-id'],
    ['ko', 'ko,ko-kr'],
    ['in', 'in,hi,hi-in'],
    ['kh', 'kh,km-kh'],
    ['sg', 'sg'],
    ['ar', 'ar,ar-er,ar-sa,ar-eg,ar-dz,ar-tn,ar-ye,ar-jo,ar-kw,ar-bh,ar-iq,ar-ly,ar-ma,ar-om,ar-sy,ar-lb,ar-ae,ar-qa,ar-ss,ar-il'],
    ['af', 'af,af-za'],
    ['tr', 'tr,tr-tr'],
    ['es', 'es,es-ar,es-bo,es-cl,es-co,es-cr,es-do,es-ec,es-es,es-gt,es-hn,es-mx,es-ni,es-pa,es-pe,es-pr,es-py,es-sv,es-uy,es-ve,es-xl,es-us'],
    ['my', 'ms,ms-bn,ms-my,my'],
    ['pt', 'pt,pt-pt,pt-br'],
    ['ja', 'ja,ja-jp,ja-ja,jp,jp-jp'],
    ['ur', 'ur,ur-pk'],
    ['de', 'de,de-at,de-ch,de-de,de-li,de-lu'],
    ['ne', 'ne,ne-np'],
    ['bn', 'bn,bn-bd,bn-in'],//孟加拉语
    ['gu', 'gu,gu-in'], // 古吉拉特语
    ['kn', 'kn,kn-in'], // 埃纳德语
    ['mr', 'mr,mr-in'], // 马拉地语
    ['pa', 'pa,pa-in'], // 旁遮普语
    ['ta', 'ta,ta-in'], // 泰米尔语
    ['te', 'te,te-in'], //泰卢固语
    ['fil', 'fil,fil-ph'],//菲律宾语
    ['it','it,it-ch,it-it'], //意大利语
    ['uk', 'uk,uk-ua'], //乌克兰语
    ['be', 'be,be-by'], //白俄罗斯语
    ['kk', 'kk,kk-kz'], //哈萨克语
    ['fa', 'fa,fa-ir'], //波斯语
    ['da', 'da,da-dk'], //丹麦语
    ['ml', 'ml,ml-in'], //马拉雅拉姆语
    ['or', 'or,or-in'], //奥里雅语
    ['as', 'as,as-in'], //阿萨姆语
    ['ka', 'ka,ka-ge'], //格鲁吉亚语
    ['sa', 'sa,sa-in'], //梵语
    ['uz', 'uz,uz-latn,uz-latn-uz,uz-cyrl,uz-cyrl-uz'], //乌兹别克语
]
MultiLang.prototype.getLangFromUrl = function (name) {
    var search = window.location.search,
        argArr = search ? search.slice(1).split('&') : [],
        argName = name || 'lang',
        argObj = {},
        j = 0
    for (var i = 0, len = argArr.length; i < len; i++) {
        j = argArr[i].indexOf('=')
        argObj[argArr[i].slice(0, j)] = argArr[i].slice(j + 1)
    }
    return argObj[argName]
}
var getAppLangFlag = false
MultiLang.prototype.getAppLang = function () {
    if (getAppLangFlag) { return }
    var navigatorLangStr = (this.getLangFromUrl(this.initArguments.queryLang) && this.getLangFromUrl(this.initArguments.queryLang).toLowerCase()) || this.getLangFromUrl('lang') || (navigator.language || navigator.userLanguage).toLowerCase(),
        langArr = this.langZip,
        len = langArr.length,
        appLang = ''
    for (var i = 0; i < len; i++) {
        if (langArr[i][1].split(',').indexOf(navigatorLangStr) > -1) {
            appLang = langArr[i][0]
            break;
        }
    }
    this.appLangString = navigatorLangStr
    this.appLang = appLang
    getAppLangFlag = true;
    return appLang
}
MultiLang.prototype.strMapToLang = function(langStr) {
    var langArr = this.langZip
    var len = langArr.length
    var resultLang = ''
    for (var i = 0; i < len; i++) {
        if (langArr[i][1].split(',').indexOf(langStr) > -1) {
            resultLang = langArr[i][0]
            break;
        }
    }
    return resultLang ? resultLang : 'en'
}
MultiLang.prototype.init = function (arg) {
    this.initArguments = arg
    this.getAppLang()
    this.initLang()
    this.listenerStorage()
}
MultiLang.prototype.listenerStorage = function () {
    var _this = this
    window.addEventListener('storage', function (event) {
        if (event.key === 'multiLang') {
            _this.setLang()
        }
    })
    Object.defineProperty(window.localStorage, 'lang', {
        configurable:true,
        get: function () {
            return localStorage.multiLang
        },
        set: function (value) {
            localStorage.multiLang = value
            _this.setLang()
        }
    })
}
MultiLang.prototype.initLang = function () {
    var allFileName = this.initArguments.name,
        langName = this.appLang,
        useLang = this.initArguments.useLang,
        urlPattern = this.initArguments.urlPattern,
        jsLang = this.initArguments.jsLang;


    var recordList = _recordLangList(allFileName, useLang);
    this.langList = _createLangList(recordList);
    
    if (allFileName) {
        if (!allFileName[langName]) {
            if (allFileName.en) {
                langName = 'en'
            }else{
                langName = Object.keys(allFileName)[0]
            }
        }
        this.packageLang = langName
        this.loadLangContent(allFileName[langName])
    } else if (useLang) {
        if (useLang.indexOf(langName) === -1) {
            langName = useLang.indexOf('en') ? 'en' : useLang[0];
        } 
        this.packageLang = langName
        if (typeof urlPattern !== 'function') {
            throw Error('urlPattern is not a function');
        } else {
            var path = urlPattern.call(null, this.packageLang);
            this.loadLangContent(path)
        }
    } else if (jsLang) {
        langName = langName in jsLang ? langName : 'en';
        this.packageLang = langName; 
        this.loadLangContent(langName);
    } 
}
MultiLang.prototype.ajaxGet = function (requestUrl, callback) {
    var xmlhttp = {}
    if (window.XMLHttpRequest) {
        xmlhttp = new window.XMLHttpRequest()
    }else{
        xmlhttp = new window.ActiveXObject('Microsoft.XMLHTTP')
    }
    xmlhttp.onreadystatechange = function () {
        if (xmlhttp.readyState === 4 && xmlhttp.status === 200) {
            if (typeof callback === 'function') {
                callback(xmlhttp.responseText)
            }
        }
    }
    xmlhttp.open('GET', requestUrl, true)
    xmlhttp.send()
}
MultiLang.prototype.loadLangContent = function (fileName) {
    var that = this;

    if (this.initArguments.dataType === 'js') {
        var langData = this.initArguments.jsLang ? 
                       this.initArguments.jsLang[fileName ? fileName : that.packageLang] : 
                       window.bgyJson;
        if (!langData) {
            throw Error('jsLang is not defined or  window.bgyJson is not exsist');
        }
        that.initArguments.callback.call(that, langData, that.appLang)
        return ;
    }

    var base_path = this.initArguments.path ? this.initArguments.path : ''; 
    var url = this.initArguments.version 
        ? (base_path + fileName + "?" + this.initArguments.version) 
        : (base_path + fileName) 
    this.ajaxGet(url, function (data) {
        var jsondata = that.initArguments.dataType === 'txt' ? data : JSON.parse(data)
        that.currentLangName = that.packageLang in _localLangNameMap ? 
                              _localLangNameMap[that.packageLang]['localName'] : that.currentLangName

        that.initArguments.callback.call(that, jsondata, that.appLang)
    })
}
MultiLang.prototype.setLang = function (langName, callback) {
    if (arguments.length === 0) {
        this.appLang = window.localStorage.multiLang
    }else{
        window.localStorage.multiLang = this.appLang = langName
    }
    this.init(this.initArguments)
    if (typeof callback === 'function') {
        callback()
    }
}
var multiLangInstacne = new MultiLang();
export default multiLangInstacne
